<?php
/**
 * Created by PhpStorm.
 * User: phillipesilva
 * Date: 23/12/2014
 * Time: 15:21
 */

namespace Folha\Logic\FichaMedica;

use Folha\Entities\SstExamefichamed;
use Folha\Entities\SstItemexamefichamed;
use Setforms2\Shared\Registry;

class FichaMedica {
    public static function deleteExamesAndItensFichaMedica($nrFichaMedica, $nrOrg)
    {
        $entityManager = Registry::getEntityManager();
        $db = $entityManager->getConnection();
        $db->beginTransaction();

        try {
            $exames = SstExamefichamed::findByNrfichamedicaAndNrorg($nrFichaMedica, $nrOrg);

            foreach ($exames as $exame) {
                self::deleteItensExame($exame->getNrexamefichamed(), $nrOrg);

                $exame->delete();
            }

            $entityManager->flush();
            $db->commit();
        } catch (\Exception $e) {
            $db->rollback();
            throw $e;
        }
    }

    private static function deleteItensExame($nrExameFicha, $nrOrg)
    {
        $itens = SstItemexamefichamed::findByNrexamefichamedAndNrorg($nrExameFicha, $nrOrg);

        foreach ($itens as $item) {
            $item->delete();
        }

        Registry::getEntityManager()->flush();
    }

    public static function getGrauObesidade($vrImc)
    {
        if($vrImc < 16) {
            return 'Magreza grave';
        } else if($vrImc >= 16 && $vrImc < 17) {
            return 'Magreza moderada';
        } else if($vrImc >= 17 && $vrImc < 18.5) {
            return 'Magreza leve';
        } else if($vrImc >= 18.5 && $vrImc < 25) {
            return 'Saudável';
        } else if($vrImc >= 25 && $vrImc < 30) {
            return 'Sobrepeso';
        } else if($vrImc >= 30 && $vrImc < 35) {
            return 'Obesidade Grau I';
        } else if($vrImc >= 35 && $vrImc < 40) {
            return 'Obesidade Grau II (severa)';
        } else if($vrImc >= 40) {
            return 'Obesidade Grau III (mórbida)';
        }

        return '';
    }
} 