IF EXISTS (SELECT *
           FROM SYSOBJECTS O, SYSUSERS U
           WHERE O.NAME = 'LIMPEZA_NOTAFISCAL' AND
                 TYPE = 'P' 			         AND
                 U.UID = O.UID             	AND
                 U.NAME = USER)
DROP PROCEDURE LIMPEZA_NOTAFISCAL
GO

CREATE PROCEDURE LIMPEZA_NOTAFISCAL(
   @P_NRLISTA       VARCHAR,
   @P_DTFINAL       DATETIME,
   @P_DSSISTLIMPEZ  VARCHAR,
   @P_NMOPERLIMPEZ  VARCHAR,
   @P_IDSISTEMA     VARCHAR)

AS

   DECLARE @V_VALOR      VARCHAR(10);
   DECLARE @V_STATUS     VARCHAR(01);
   DECLARE @V_CDFILIAL   VARCHAR(04);

   DECLARE @V_ERROR      VARCHAR(2000);
   DECLARE @V_NRORDEM    VARCHAR(03);

   DECLARE @V_DSIP       VARCHAR(50);
   DECLARE @V_DSUSUARIO  VARCHAR(50);
   DECLARE @V_DSRDM      VARCHAR(50);
   DECLARE @V_DSMETODO   VARCHAR(250);
   DECLARE @V_DSOPERADOR VARCHAR(12);

   DECLARE @V_EXCLUNOTAFISCAL  NUMERIC;

   DECLARE @V_COUNT_COMMIT    NUMERIC;
   DECLARE @V_NUM_TO_COMMIT   NUMERIC; -- NUMERO UTILIZADO PARA REGULARIZAR A QUANTIDADE DE DMLS PARA O COMMIT.


   DECLARE @V_NOTAFISCAL_CDFILIAL     VARCHAR(04);
   DECLARE @V_NOTAFISCAL_NRLANCTONF   VARCHAR(10);
   DECLARE @V_NOTAFISCAL_IDENTRSAIDOP VARCHAR(01);

   DECLARE @err varchar(100);

   DECLARE C_LISTA CURSOR FOR
      (SELECT CDLISTA AS CDFILIAL
       FROM LISTA
       WHERE NRLISTA = @P_NRLISTA);

BEGIN

   ALTER TABLE NOTAFISCAL  DISABLE TRIGGER LOG_FIS_NOTAFISCAL;
   ALTER TABLE ITEMPRODUTO  DISABLE TRIGGER NF_BAIXA_AF;

   SET @V_COUNT_COMMIT = 1;
   SET @V_NUM_TO_COMMIT = 1000;
   SET @V_EXCLUNOTAFISCAL = 0;

   EXEC WEBTUNNING @V_DSIP, @V_DSUSUARIO, @V_DSRDM, @V_DSMETODO, @V_DSOPERADOR;

   SET @V_NRORDEM = '0';

   UPDATE TRABLIMPEZA
   SET IDSTATUSLIMPEZA = 'A'
   WHERE IDLIMPEZA = @P_IDSISTEMA;

   SET @V_NRORDEM =  RIGHT(REPLICATE('0', 3) + CONVERT(CHAR(3),(CONVERT(INT, @V_NRORDEM)+1)), 3);

   UPDATE TABLIMPEZA
      SET NRORDEMLIMPEZA = @V_NRORDEM
    WHERE IDLIMPEZA = @P_IDSISTEMA
      AND NMTABELALIMP = 'NOTAFISCAL';

    IF NOT(@@ROWCOUNT > 0) BEGIN
       INSERT INTO TABLIMPEZA
       VALUES
       (@P_IDSISTEMA, 'NOTAFISCAL', @V_NRORDEM);
    END;

    INSERT INTO TRABPROCLIMPEZA
      (IDLIMPEZA, NMTABELALIMP, IDSITUPROCLIMP)
    VALUES
       (@P_IDSISTEMA, 'NOTAFISCAL', 'A');

    COMMIT;

   SET @V_STATUS = 'S';

   OPEN C_LISTA;
   FETCH NEXT FROM C_LISTA INTO @V_CDFILIAL
   WHILE (@@FETCH_STATUS = 0)
   BEGIN
      DECLARE C_NOTAFISCAL CURSOR FOR
         SELECT NOTAFISCAL.CDFILIAL, NOTAFISCAL.NRLANCTONF, IDENTRSAIDOP
         FROM NOTAFISCAL
         WHERE NOTAFISCAL.CDFILIRECE  = @V_CDFILIAL AND
               IDENTRSAIDOP = 'E'                  AND
               NOTAFISCAL.DTENTRSAID <= @P_DTFINAL
         UNION ALL
         SELECT NOTAFISCAL.CDFILIAL, NOTAFISCAL.NRLANCTONF, IDENTRSAIDOP
         FROM NOTAFISCAL
         WHERE NOTAFISCAL.CDFILIEMIT  = @V_CDFILIAL AND
               IDENTRSAIDOP = 'S'                 AND
               NOTAFISCAL.DTENTRSAID <= @P_DTFINAL

      OPEN C_NOTAFISCAL
      FETCH NEXT FROM C_NOTAFISCAL INTO @V_NOTAFISCAL_CDFILIAL, @V_NOTAFISCAL_NRLANCTONF, @V_NOTAFISCAL_IDENTRSAIDOP;
      WHILE (@@FETCH_STATUS = 0)
      BEGIN

         SET @V_STATUS = 'S';

         IF @V_STATUS = 'S' BEGIN
            SELECT @V_VALOR = MAX(L.CDFILIAL)
            FROM LANCTOESTOQ L
            WHERE L.CDFILIAL   = @V_NOTAFISCAL_CDFILIAL AND
                  L.NRLANCTONF = @V_NOTAFISCAL_NRLANCTONF;

            IF @V_VALOR IS NOT NULL BEGIN
               SET @V_STATUS = 'N';
            END;
         END;

         IF @V_STATUS = 'S' BEGIN
            SELECT @V_VALOR = MAX(L.CDFILIAL)
            FROM MAPARESUMECF L
            WHERE L.CDFILIAL   = @V_NOTAFISCAL_CDFILIAL AND
                  L.NRLANCTONF = @V_NOTAFISCAL_NRLANCTONF;

            IF @V_VALOR IS NOT NULL BEGIN
               SET @V_STATUS = 'N';
            END;

          END;

         IF @V_STATUS = 'S' BEGIN
            SELECT @V_VALOR = MAX(L.CDFILIAL)
            FROM MAPARESUMECF L
            WHERE L.CDFILIAL   = @V_NOTAFISCAL_CDFILIAL AND
                  L.NRLANCTONF = @V_NOTAFISCAL_NRLANCTONF;

            IF @V_VALOR IS NOT NULL BEGIN
               SET @V_STATUS = 'N';
            END;

         END;

         IF @V_STATUS = 'S' BEGIN
            SELECT @V_VALOR = MAX(L.CDFILIAL)
            FROM INVOICE L
            WHERE L.CDFILIAL   = @V_NOTAFISCAL_CDFILIAL AND
                  L.NRLANCTONF = @V_NOTAFISCAL_NRLANCTONF;

            IF @V_VALOR IS NOT NULL BEGIN
               SET @V_STATUS = 'N';
            END;

         END;

         IF @V_STATUS = 'S' BEGIN
            SELECT @V_VALOR = MAX(L.CDFILIAL)
            FROM INVOICE L
            WHERE L.CDFILIAL   = @V_NOTAFISCAL_CDFILIAL AND
                  L.NRLANCTONF = @V_NOTAFISCAL_NRLANCTONF;

            IF @V_VALOR IS NOT NULL BEGIN
               SET @V_STATUS = 'N';
            END;

         END;

         IF @V_STATUS = 'S' BEGIN

            SELECT @V_VALOR = MAX(C.CDFILIAL)
            FROM CONTARECEBER C, BOLETRECEBER B
            WHERE C.CDFILIAL      = @V_NOTAFISCAL_CDFILIAL    AND
                  C.NRLANCTONF    = @V_NOTAFISCAL_NRLANCTONF  AND
                  C.CDFILIBOLREC  = B.CDFILIAL               AND
                  C.NRLANBOLREC   = B.NRLANBOLREC            AND
                  NOT EXISTS (SELECT CDFILIAL
                              FROM BAIXARECEBIDA I
                              WHERE I.CDFILIAL   = B.CDFILIAL AND
                                    i.NRBAIXAREC = B.NRBAIXAREC);

            IF @V_VALOR IS NOT NULL BEGIN
               SET @V_STATUS = 'N';
            END;

         END;

         IF @V_NOTAFISCAL_IDENTRSAIDOP = 'E' BEGIN
            DELETE AJCTPAGAR
            WHERE CDFILIAL   = @V_NOTAFISCAL_CDFILIAL AND
                  NRLANCTONF = @V_NOTAFISCAL_NRLANCTONF;

            DELETE CONTAGERADA
            WHERE CDFILIALPAG = @V_NOTAFISCAL_CDFILIAL AND
                  NRLANCTOPAG = @V_NOTAFISCAL_NRLANCTONF;

            DELETE ADIANTAPAGAR
            WHERE CDFILIAL = @V_NOTAFISCAL_CDFILIAL AND
                  NRLANCTONF = @V_NOTAFISCAL_NRLANCTONF;

         END;

         IF @V_NOTAFISCAL_IDENTRSAIDOP = 'S' BEGIN
            DELETE AJCTRECEBER
             WHERE CDFILIAL   = @V_NOTAFISCAL_CDFILIAL AND
                   NRLANCTONF = @V_NOTAFISCAL_NRLANCTONF;

            DELETE PARCELAVENDA
             WHERE CDFILIAL   = @V_NOTAFISCAL_CDFILIAL AND
                   NRLANCTONF = @V_NOTAFISCAL_NRLANCTONF;

            DELETE ADIANTARECEB
             WHERE CDFILIAL   = @V_NOTAFISCAL_CDFILIAL AND
                   NRLANCTONF = @V_NOTAFISCAL_NRLANCTONF;
         END;


         IF @V_STATUS = 'S' BEGIN

            SELECT @V_VALOR = MAX(C.CDFILIAL)
            FROM CONTAPAGAR C, BOLETPAGAR B
            WHERE C.CDFILIAL      = @V_NOTAFISCAL_CDFILIAL    AND
                  C.NRLANCTONF    = @V_NOTAFISCAL_NRLANCTONF  AND
                  C.CDFILIBPAG    = B.CDFILIAL               AND
                  C.NRLANBOLPAG   = B.NRLANBOLPAG            AND
                  NOT EXISTS (SELECT CDFILIAL
                              FROM BAIXAPAGA I
                              WHERE I.CDFILIAL   = B.CDFILIAL AND
                                    i.NRBAIXAPAG = B.NRBAIXAPAG);

            IF @V_VALOR IS NOT NULL BEGIN
               SET @V_STATUS = 'N';
            END;

         END;

         IF @V_STATUS = 'S' BEGIN
            UPDATE MOVOCORR
            SET CDFILIALNF   = NULL,
                NRLANCTONF = NULL
            WHERE CDFILIALNF   = @V_NOTAFISCAL_CDFILIAL AND
                  NRLANCTONF   = @V_NOTAFISCAL_NRLANCTONF;

            UPDATE MAPAAPURAC
            SET CDFILIAL   = NULL,
                NRLANCTONF = NULL
            WHERE CDFILIAL   = @V_NOTAFISCAL_CDFILIAL AND
                  NRLANCTONF = @V_NOTAFISCAL_NRLANCTONF;

            UPDATE PREVRETI
            SET CDFILIAL   = NULL,
                NRLANCTONF = NULL
            WHERE CDFILIAL   = @V_NOTAFISCAL_CDFILIAL AND
                  NRLANCTONF = @V_NOTAFISCAL_NRLANCTONF;

            UPDATE ITEMAUTF
            SET NRLANCTONF = NULL
            WHERE CDFILLANC   = @V_NOTAFISCAL_CDFILIAL AND
                  NRLANCTONF = @V_NOTAFISCAL_NRLANCTONF;

            UPDATE AMOSTRAPROC
            SET CDFILIAL   = NULL,
                NRLANCTONF = NULL
            WHERE CDFILIAL   = @V_NOTAFISCAL_CDFILIAL AND
                  NRLANCTONF = @V_NOTAFISCAL_NRLANCTONF;

            UPDATE ITEMROMANEIO
            SET CDFILIAL   = NULL,
                NRLANCTONF = NULL
            WHERE CDFILIAL   = @V_NOTAFISCAL_CDFILIAL AND
                  NRLANCTONF = @V_NOTAFISCAL_NRLANCTONF;

            UPDATE ROMANEIONF
            SET CDFILIAL   = NULL,
                NRLANCTONF = NULL
            WHERE CDFILIAL   = @V_NOTAFISCAL_CDFILIAL AND
                  NRLANCTONF = @V_NOTAFISCAL_NRLANCTONF;

            UPDATE ITREQUESTO
            SET CDFILIAL   = NULL,
                NRLANCTONF = NULL
            WHERE CDFILIAL   = @V_NOTAFISCAL_CDFILIAL AND
                  NRLANCTONF = @V_NOTAFISCAL_NRLANCTONF;

            UPDATE APURFATUFAS
            SET CDFILIAL   = NULL,
                NRLANCTONF = NULL
            WHERE CDFILIAL   = @V_NOTAFISCAL_CDFILIAL AND
                  NRLANCTONF = @V_NOTAFISCAL_NRLANCTONF;

            UPDATE EXPNFFRETE
            SET CDFILIAL   = NULL,
                NRLANCTONF = NULL
            WHERE CDFILIAL   = @V_NOTAFISCAL_CDFILIAL AND
                  NRLANCTONF = @V_NOTAFISCAL_NRLANCTONF;

            UPDATE NFRELACAFSAI
            SET CDFILIAL   = NULL,
                NRLANCTONF = NULL
            WHERE CDFILIAL   = @V_NOTAFISCAL_CDFILIAL AND
                  NRLANCTONF = @V_NOTAFISCAL_NRLANCTONF;

            UPDATE NFRELACPEXOL
            SET CDFILIAL   = NULL,
                NRLANCTONF = NULL
            WHERE CDFILIAL   = @V_NOTAFISCAL_CDFILIAL AND
                  NRLANCTONF = @V_NOTAFISCAL_NRLANCTONF;

            UPDATE NFRELACORC
            SET CDFILIAL   = NULL,
                NRLANCTONF = NULL
            WHERE CDFILIAL   = @V_NOTAFISCAL_CDFILIAL AND
                  NRLANCTONF = @V_NOTAFISCAL_NRLANCTONF;

            UPDATE  FORMULARIONF
            SET CDFILIAL   = NULL,
                NRLANCTONF = NULL
            WHERE CDFILIAL   = @V_NOTAFISCAL_CDFILIAL AND
                  NRLANCTONF = @V_NOTAFISCAL_NRLANCTONF;

            UPDATE OCORRERFATUR
            SET CDFILIAL   = NULL,
                NRLANCTONF = NULL
            WHERE CDFILIAL   = @V_NOTAFISCAL_CDFILIAL AND
                  NRLANCTONF = @V_NOTAFISCAL_NRLANCTONF;

            UPDATE AUDITORIA
            SET CDFILIAL    = NULL,
                NRLANCTONF  = NULL,
                NRSEQITPROD = NULL
            WHERE CDFILIAL   = @V_NOTAFISCAL_CDFILIAL AND
                  NRLANCTONF = @V_NOTAFISCAL_NRLANCTONF;

            UPDATE ITEMVENDA
            SET CDFILIAL    = NULL,
                NRLANCTONF  = NULL,
                NRSEQITPROD = NULL
            WHERE CDFILIAL   = @V_NOTAFISCAL_CDFILIAL AND
                  NRLANCTONF = @V_NOTAFISCAL_NRLANCTONF;

            UPDATE ITVENDAVMN
            SET CDFILIAL    = NULL,
                NRLANCTONF  = NULL,
                NRSEQITPROD = NULL
            WHERE CDFILIAL   = @V_NOTAFISCAL_CDFILIAL AND
                  NRLANCTONF = @V_NOTAFISCAL_NRLANCTONF;

            DELETE CONTARECEBER
            WHERE CDFILIAL   = @V_NOTAFISCAL_CDFILIAL AND
                  NRLANCTONF = @V_NOTAFISCAL_NRLANCTONF;

            DELETE CONTAPAGAR
            WHERE CDFILIAL   = @V_NOTAFISCAL_CDFILIAL AND
                  NRLANCTONF = @V_NOTAFISCAL_NRLANCTONF;

            DELETE SERVPLANO
            WHERE CDFILIAL   = @V_NOTAFISCAL_CDFILIAL AND
                  NRLANCTONF = @V_NOTAFISCAL_NRLANCTONF;

            DELETE NFRELACAF
            WHERE CDFILIAL   = @V_NOTAFISCAL_CDFILIAL AND
                  NRLANCTONF = @V_NOTAFISCAL_NRLANCTONF;

            DELETE LANCDESPFATU
            WHERE CDFILIAL   = @V_NOTAFISCAL_CDFILIAL AND
                  NRLANCTONF = @V_NOTAFISCAL_NRLANCTONF;

            DELETE NFABASTEROTA
            WHERE CDFILIAL   = @V_NOTAFISCAL_CDFILIAL AND
                  NRLANCTONF = @V_NOTAFISCAL_NRLANCTONF;

            DELETE PARCLANCATIV
            WHERE CDFILIAL   = @V_NOTAFISCAL_CDFILIAL AND
                  NRLANCTONF = @V_NOTAFISCAL_NRLANCTONF;

            DELETE CTRAPUITPROD
            WHERE CDFILIAL   = @V_NOTAFISCAL_CDFILIAL AND
                  NRLANCTONF = @V_NOTAFISCAL_NRLANCTONF;

            DELETE SERVFATU
            WHERE CDFILIAL   = @V_NOTAFISCAL_CDFILIAL AND
                  NRLANCTONF = @V_NOTAFISCAL_NRLANCTONF;

            DELETE NOTAFISCAL
            WHERE NOTAFISCAL.CDFILIAL = @V_NOTAFISCAL_CDFILIAL 
              AND NOTAFISCAL.NRLANCTONF = @V_NOTAFISCAL_NRLANCTONF;
              
            SET @V_EXCLUNOTAFISCAL = @@ROWCOUNT + @V_EXCLUNOTAFISCAL;

            IF @V_COUNT_COMMIT >= @V_NUM_TO_COMMIT BEGIN
               UPDATE TRABPROCLIMPEZA
                 SET QTREGEXCLIMPEZA = @V_EXCLUNOTAFISCAL
               WHERE IDLIMPEZA = @P_IDSISTEMA
                 AND NMTABELALIMP = 'NOTAFISCAL';

              /*CONTROLE DE COMMIT HA CADA 1000 REGISTRO DELETEDO  E PARA ATUALIZAR A TELA DE LIMPEZA*/
              SET @V_COUNT_COMMIT= 1;
              COMMIT;
            END
            ELSE BEGIN
              SET @V_COUNT_COMMIT= @V_COUNT_COMMIT + 1;
            END;
         END;
         FETCH NEXT FROM C_NOTAFISCAL INTO @V_NOTAFISCAL_CDFILIAL, @V_NOTAFISCAL_NRLANCTONF, @V_NOTAFISCAL_IDENTRSAIDOP;
      END;
      CLOSE C_NOTAFISCAL;
      DEALLOCATE C_NOTAFISCAL;

      FETCH NEXT FROM C_LISTA INTO @V_CDFILIAL;
   END;
   CLOSE C_LISTA;
   DEALLOCATE C_LISTA;


   UPDATE TRABPROCLIMPEZA
      SET IDSITUPROCLIMP = 'C',
          QTREGEXCLIMPEZA = @V_EXCLUNOTAFISCAL,
          DTHRFINLIMPEZA = GETDATE()
    WHERE IDLIMPEZA = @P_IDSISTEMA AND
          NMTABELALIMP = 'NOTAFISCAL';

   DELETE FROM TRABLIMPEZA
   WHERE IDLIMPEZA = @P_IDSISTEMA;

   INSERT INTO LOGLIMPEZA (DSSISTLIMPEZ, NMTABLIMP, DTLIMPDADOS, NMOPERLIMPEZ, DTFINALIMPEZ, DSLIMPEZA, DSRDMUSULOGL, DSENDUSULOGL, DSNMUSUOLOGL, DSMETUSULOGL, QTDLINHAEXCL)
   VALUES (@P_DSSISTLIMPEZ, 'NOTAFISCAL', GETDATE(), @P_NMOPERLIMPEZ, @P_DTFINAL, 'NOTAFISCAL', @V_DSRDM, @V_DSIP, @V_DSUSUARIO, @V_DSMETODO, @V_EXCLUNOTAFISCAL);

   COMMIT;

   ALTER TABLE NOTAFISCAL  ENABLE TRIGGER LOG_FIS_NOTAFISCAL;
   ALTER TABLE ITEMPRODUTO  ENABLE TRIGGER NF_BAIXA_AF;


   IF @Err <> 0 BEGIN
      DELETE FROM TRABLIMPEZA
      WHERE IDLIMPEZA = @P_IDSISTEMA;

      IF (@V_EXCLUNOTAFISCAL > 0) BEGIN
         INSERT INTO LOGLIMPEZA (DSSISTLIMPEZ, NMTABLIMP, DTLIMPDADOS, NMOPERLIMPEZ, DTFINALIMPEZ, DSLIMPEZA, DSRDMUSULOGL, DSENDUSULOGL, DSNMUSUOLOGL, DSMETUSULOGL, QTDLINHAEXCL)
         VALUES (@P_DSSISTLIMPEZ, 'NOTAFISCAL', GETDATE(), @P_NMOPERLIMPEZ, @P_DTFINAL, 'NOTAFISCAL', @V_DSRDM, @V_DSIP, @V_DSUSUARIO, @V_DSMETODO, @V_EXCLUNOTAFISCAL);
      END;

      COMMIT;

      ALTER TABLE NOTAFISCAL  ENABLE TRIGGER LOG_FIS_NOTAFISCAL;
      ALTER TABLE ITEMPRODUTO  ENABLE TRIGGER NF_BAIXA_AF;


      RETURN (@Err)
   END;

END;
GO


-- VERSAO --
EXEC ATUVEROBJ 'LIMPEZA_NOTAFISCAL','5.05.009';
GO

